#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 2A.data - Classification, régression, anomalies - énoncé
# 
# Le jeu de données [Wine Quality Data Set](https://archive.ics.uci.edu/ml/datasets/Wine+Quality) contient 5000 vins décrits par leurs caractéristiques chimiques et évalués par un expert. Peut-on s'approcher de l'expert à l'aide d'un modèle de machine learning.

# In[1]:


get_ipython().run_line_magic('matplotlib', 'inline')
import matplotlib.pyplot as plt


# In[2]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Les données
# 
# On peut les récupérer sur [github...data_2a](https://github.com/sdpython/ensae_teaching_cs/tree/master/src/ensae_teaching_cs/data/data_1a).

# In[3]:


from ensae_teaching_cs.data import wines_quality
from pandas import read_csv
df = read_csv(wines_quality(local=True, filename=True))
df.head()


# ## Exercice 1 : afficher la distribution des notes
# 
# La fonction [hist](https://pandas.pydata.org/pandas-docs/stable/reference/api/pandas.DataFrame.hist.html) est simple, efficice.

# ## Exercice 2 : séparation train / test
# 
# La fonction est tellement utilisée que vous la trouverez rapidement.

# ## Exercice 3 : la variable couleur n'est pas numérique
# 
# M... [OneHotEncoder](https://scikit-learn.org/stable/modules/generated/sklearn.preprocessing.OneHotEncoder.html).

# In[4]:





# ## Exercice 3 : premier classifieur
# 
# Vous trouverez aussi tout seul. Quelques fonctions pourront vous aider à évaluer le modèle [confusion_matrix](https://scikit-learn.org/stable/modules/generated/sklearn.metrics.confusion_matrix.html), [classification_report](https://scikit-learn.org/stable/modules/generated/sklearn.metrics.classification_report.html).

# Beaucoup mieux.

# ## Exercice 4 : courbe ROC
# 
# Quelques aides...

# In[5]:


from sklearn.metrics import roc_curve, auc

# labels = pipe.steps[1][1].classes_
# y_score = pipe.predict_proba(X_test)

fpr = dict()
tpr = dict()
roc_auc = dict()
# for i, cl in enumerate(labels):
#     fpr[cl], tpr[cl], _ = roc_curve(y_test == cl, y_score[:, i])
#     roc_auc[cl] = auc(fpr[cl], tpr[cl])


# In[6]:


# fig, ax = plt.subplots(1, 1, figsize=(8,4))
# for k in roc_auc:
#     ax.plot(fpr[k], tpr[k], label="c%d = %1.2f" % (k, roc_auc[k]))
# ax.legend();


# ## Exercice 5 : anomalies
# 
# Une anomalie est un point aberrant. Cela revient à dire que sa probabilité qu'un tel événement se reproduise est faible. Un modèle assez connu est [EllipticEnvelope](https://scikit-learn.org/stable/auto_examples/plot_anomaly_comparison.html). On suppose que si le modèle détecte une anomalie, un modèle de prédiction aura plus de mal à prédire. On réutilise le pipeline précédent en changeant juste la dernière étape.

# In[7]:


from sklearn.covariance import EllipticEnvelope


# ## Exercice 6 : régression
# 
# La note est numérique, pourquoi ne pas essayer une régression.

# In[8]:


from sklearn.ensemble import RandomForestRegressor


# ## Exercice 7 : intervalle de confiance
#     
# Comment constuire un intervalle de confiance avec un classifieur et un régresseur. Rien de théorique, juste des idées et un peu de bidouille.

# In[9]: